#include <SoftwareSerial.h>
/**
 * Use this sketch for point-point(P2P) communication of LoRa modules.
 * This sketch is for transmitting messages.
 **/

SoftwareSerial loraSerial(2, 3);
#define debugSerial Serial

void setup() {
  while(!debugSerial || !loraSerial);

  debugSerial.begin(115200);
  loraSerial.begin(57600);

  //clear buffer just in case
  loraSerial.readString();
  
  // use only LoRa stack
  sendCommand("mac pause");
  
  //sendCommand("radio set freq 921900000");
  /* uncomment this 2 lines if you want to use LoRaWAN stack
   For this case you should be using LoRaWAN library*/
  // sendCommand("mac resume");
  // while(1); 
}

void loop() {

  byte mydata[3] = {0, 1 ,2};

  //send message
  String message = "radio tx " + convertBytesToString(mydata, sizeof(mydata));
  sendCommand(message.c_str());

  //delay 10s
  delay(10000);
  
}
char btohexa_high(unsigned char b) {
  b >>= 4;
  return (b > 0x9u) ? b + 'A' - 10 : b + '0';
}

char btohexa_low(unsigned char b) {
  b &= 0x0F;
  return (b > 0x9u) ? b + 'A' - 10 : b + '0';
}

String convertBytesToString(const byte *buf, size_t length){

  String str ="";
  
  for (size_t i = 0; i < length; i++) {
    str += btohexa_high(buf[i]);
    str += btohexa_low(buf[i]);
  }
  return str;
}

void sendCommand(const char* str){
  //sending command
  loraSerial.println(str);
  
 //read the response
  String s = loraSerial.readStringUntil('\n'); 
  //print out the response
  debugSerial.print("Response: ");
  debugSerial.println(s);
}

